/*!
 * (c) 2006-2007 EPFL, Lausanne, Switzerland
 * Thomas Lochmatter
 */

#include <assert.h>
#include "khepera3_drive.h"
#include "khepera3.h"

/*** Module initialization ***/

void khepera3_drive_init() {
	khepera3_motor_init(&(khepera3.motor_left));
	khepera3_motor_init(&(khepera3.motor_right));
	khepera3.motor_left.direction = -1;
	khepera3.motor_right.direction = 1;
}

/*** Functions to set/get values on both motors ***/

int khepera3_drive_stop() {
	khepera3_motor_stop(&(khepera3.motor_left));
	khepera3_motor_stop(&(khepera3.motor_right));
}

int khepera3_drive_start() {
	khepera3_motor_start(&(khepera3.motor_left));
	khepera3_motor_start(&(khepera3.motor_right));
}

int khepera3_drive_idle() {
	khepera3_motor_idle(&(khepera3.motor_left));
	khepera3_motor_idle(&(khepera3.motor_right));
}

int khepera3_drive_set_speed(int speed_left, int speed_right) {
	khepera3_motor_set_speed(&(khepera3.motor_left), speed_left);
	khepera3_motor_set_speed(&(khepera3.motor_right), speed_right);
}

int khepera3_drive_set_speed_using_profile(int speed_left, int speed_right) {
	khepera3_motor_set_speed_using_profile(&(khepera3.motor_left), speed_left);
	khepera3_motor_set_speed_using_profile(&(khepera3.motor_right), speed_right);
}

int khepera3_drive_goto_position(int position_left, int position_right) {
	khepera3_motor_goto_position(&(khepera3.motor_left), position_left);
	khepera3_motor_goto_position(&(khepera3.motor_right), position_right);
}

int khepera3_drive_goto_position_using_profile(int position_left, int position_right) {
	khepera3_motor_goto_position_using_profile(&(khepera3.motor_left), position_left);
	khepera3_motor_goto_position_using_profile(&(khepera3.motor_right), position_right);
}

int khepera3_drive_set_current_position(int position_left, int position_right) {
	khepera3_motor_set_current_position(&(khepera3.motor_left), position_left);
	khepera3_motor_set_current_position(&(khepera3.motor_right), position_right);
}

int khepera3_drive_get_current_speed() {
	khepera3_motor_get_current_speed(&(khepera3.motor_left));
	khepera3_motor_get_current_speed(&(khepera3.motor_right));
}

int khepera3_drive_get_current_position() {
	khepera3_motor_get_current_position(&(khepera3.motor_left));
	khepera3_motor_get_current_position(&(khepera3.motor_right));
}

int khepera3_drive_get_current_torque() {
	khepera3_motor_get_current_torque(&(khepera3.motor_left));
	khepera3_motor_get_current_torque(&(khepera3.motor_right));
}
