/*!
 * (c) 2006-2007 EPFL, Lausanne, Switzerland
 * Thomas Lochmatter
 */

#ifndef KHEPERA3_DRIVE
#define KHEPERA3_DRIVE

#include "i2cal.h"

//! Initializes this module.
int khepera3_drive_initialize();

//! Stops both motors immediately.
int khepera3_drive_stop();
//! Puts both motors in normal (control) mode.
int khepera3_drive_start();
//! Puts both motors in idle mode.
int khepera3_drive_idle();

//! Sets the motor speeds.
int khepera3_drive_set_speed(int speed_left, int speed_right);
//! Sets the motor speeds and uses the acceleration profile to reach that speed.
int khepera3_drive_set_speed_using_profile(int speed_left, int speed_right);

//! Goes to a specific motor position.
int khepera3_drive_goto_position(int position_left, int position_right);
//! Goes to a specific motor position using the acceleration profile.
int khepera3_drive_goto_position_using_profile(int position_left, int position_right);

//! Sets the current encoder position.
int khepera3_drive_set_current_position(int position_left, int position_right);

//! Reads the current speed and updates the corresponding value the motor structures.
int khepera3_drive_get_current_speed();
//! Reads the current position and updates the corresponding value the motor structures.
int khepera3_drive_get_current_position();
//! Reads the current torque and updates the corresponding value the motor structures.
int khepera3_drive_get_current_torque();

#endif
