/*!
 * (c) 2006-2007 EPFL, Lausanne, Switzerland
 * Thomas Lochmatter
 */

#include "khepera3.h"
#include "commandline.h"

// Prints the help text.
void help() {
	printf("Prints the firmware version of the dsPIC and the two motor controller PICs.\r\n");
	printf("Usage:\r\n");
	printf("  firmware_version\r\n");
}

// Main program.
int main(int argc, char *argv[]) {
	// General initialization
	khepera3_init();

	// Command line parsing
	commandline_init();
	commandline_parse(argc, argv);

	// Help
	if (commandline_option_provided("-h", "--help")) {
		help();
		exit(1);
	}

	// Read and display firmware version
	khepera3_dspic_firmware_version();
	khepera3_motor_firmware_version(&(khepera3.motor_left));
	khepera3_motor_firmware_version(&(khepera3.motor_right));
	printf("dsPIC: version %d, revision %d\r\n", khepera3.dspic.firmware_version, khepera3.dspic.firmware_revision);
	printf("Left motor: version %d, revision %d\r\n", khepera3.motor_left.firmware_version, khepera3.motor_left.firmware_revision);
	printf("Right motor: version %d, revision %d\r\n", khepera3.motor_right.firmware_version, khepera3.motor_right.firmware_revision);
	return 0;
}

