/*!
 * (c) 2006-2007 EPFL, Lausanne, Switzerland
 * Thomas Lochmatter
 */

#include "khepera3.h"
#include "commandline.h"

// Prints the help text.
void help() {
	printf("Initializes the motors (PID, mode, acceleration profile, ...).\r\n");
	printf("This program must be run before the motors are used.\r\n");
	printf("Usage: motor_initialize\r\n");
}

// Main program.
int main(int argc, char *argv[]) {
	// Command line parsing
	commandline_init();
	commandline_parse(argc, argv);

	// Help
	if (commandline_option_provided("-h", "--help")) {
		help();
		exit(1);
	}

	// Initialization
	khepera3_init();

	// Initialize left motor
	if (khepera3_motor_initialize(&(khepera3.motor_left))) {
		printf("Left motor initialized.\r\n");
	} else {
		printf("Left motor: initialization failed.\r\n");
	}

	// Initialize right motor
	if (khepera3_motor_initialize(&(khepera3.motor_right))) {
		printf("Right motor initialized.\r\n");
	} else {
		printf("Right motor: initialization failed.\r\n");
	}

	return 0;
}
